//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A8C3FDD038A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A8C3FDD038A.cm

//## begin module%3A8C3FDD038A.cp preserve=no
//## end module%3A8C3FDD038A.cp

//## Module: CGroupBase%3A8C3FDD038A; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/CGroupBase.cxx

//## begin module%3A8C3FDD038A.additionalIncludes preserve=no
//## end module%3A8C3FDD038A.additionalIncludes

//## begin module%3A8C3FDD038A.includes preserve=yes
#include <XSUtil/Parse/ModelExpression.h>
#include <XSUtil/Parse/ModelExprContexts.h>
//## end module%3A8C3FDD038A.includes

// Parameter
#include <XSModel/Parameter/Parameter.h>
// SumComponent
#include <XSModel/Model/Component/SumComponent.h>
// Component
#include <XSModel/Model/Component/Component.h>
// ComponentCreator
#include <XSModel/Model/Component/ComponentCreator.h>
// CGroupBase
#include <XSModel/Model/Component/CGroupBase.h>


//## begin module%3A8C3FDD038A.declarations preserve=no
//## end module%3A8C3FDD038A.declarations

//## begin module%3A8C3FDD038A.additionalDeclarations preserve=yes
#include <XSModel/Model/UniqueEnergy.h>
#include <XSModel/Model/Component/AddComponent.h>
#include <XSModel/Model/Component/AddTableComponent.h>
#include <XSModel/Model/Component/ComponentGroup.h>
#include <XSModel/Model/Component/MulComponent.h>
#include <XSModel/Model/Component/MulTableComponent.h>
#include <XSModel/Parameter/ModParam.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSUtil/Utils/XSstream.h>
#include <XSUtil/Utils/XSutility.h>
#include <XSstreams.h>
#include <XSsymbol.h>
#include <XSModel/Model/ModelBase.h>
#include <iterator>
#include <typeinfo>
#include <memory>
#include <stack>
//## end module%3A8C3FDD038A.additionalDeclarations


// Class CGroupBase 

//## begin CGroupBase::count%3A8C42C2038D.attr preserve=no  implementation: static int {U} 0
int CGroupBase::s_count = 0;
//## end CGroupBase::count%3A8C42C2038D.attr

CGroupBase::CGroupBase(const CGroupBase &right)
  //## begin CGroupBase::CGroupBase%3A8C3E710351_copy.hasinit preserve=yes
  : m_index(right.m_index), 
    m_nested(right.m_nested),
    m_componentInfo(right.m_componentInfo),// non-owning. 
    m_groupFlux(right.m_groupFlux->clone(this)),  // owning
    m_parent(right.m_parent),
    m_elements()
  //## end CGroupBase::CGroupBase%3A8C3E710351_copy.hasinit
  //## begin CGroupBase::CGroupBase%3A8C3E710351_copy.initialization preserve=yes
  //## end CGroupBase::CGroupBase%3A8C3E710351_copy.initialization
{
  //## begin CGroupBase::CGroupBase%3A8C3E710351_copy.body preserve=yes
//  m_groupFlux = right.m_groupFlux->clone(this); 
  ComponentListConstIterator ic = right.m_elements.begin();
  ComponentListConstIterator icEnd = right.m_elements.end();
  while ( ic != icEnd)
  {
        m_elements.push_back((*ic)->clone(this));   
        ++ic;    
  }     
  ++s_count;
  //## end CGroupBase::CGroupBase%3A8C3E710351_copy.body
}

CGroupBase::CGroupBase (ModelExpression<ModExprTreeMember>& gs, ModelBase* p, bool nest)
  //## begin CGroupBase::CGroupBase%3A8C4219030D.hasinit preserve=yes
  : m_index(++s_count), 
    m_nested(nest),
    m_componentInfo(&gs),// non-owning.
    m_groupFlux(new SumComponent(this)),  // owning
    m_parent(p),  
    m_elements()
  //## end CGroupBase::CGroupBase%3A8C4219030D.hasinit
  //## begin CGroupBase::CGroupBase%3A8C4219030D.initialization preserve=yes
  //## end CGroupBase::CGroupBase%3A8C4219030D.initialization
{
  //## begin CGroupBase::CGroupBase%3A8C4219030D.body preserve=yes
  //## end CGroupBase::CGroupBase%3A8C4219030D.body
}


CGroupBase::~CGroupBase()
{
  //## begin CGroupBase::~CGroupBase%3A8C3E710351_dest.body preserve=yes
  delete m_groupFlux;

  ComponentListIterator it = m_elements.begin();
  ComponentListIterator itEnd = m_elements.end();
  while (it != itEnd)
  {
      //SumComponent's are owned by their ComponentGroup - don't delete them here
      if(!dynamic_cast<SumComponent*>(*it))
	  delete *it;

      ++it;
  }

  --s_count;
  //## end CGroupBase::~CGroupBase%3A8C3E710351_dest.body
}


CGroupBase & CGroupBase::operator=(const CGroupBase &right)
{
  //## begin CGroupBase::operator=%3A8C3E710351_assign.body preserve=yes
  CGroupBase temp(right);
  swap(temp);
  return *this;
  //## end CGroupBase::operator=%3A8C3E710351_assign.body
}



//## Other Operations (implementation)
void CGroupBase::swap (CGroupBase& right)
{
  //## begin CGroupBase::swap%3A8C3F8A0352.body preserve=yes
  std::swap(m_index,right.m_index);
  std::swap(m_nested,right.m_nested);
  std::swap(m_groupFlux,right.m_groupFlux);
  std::swap(m_componentInfo,right.m_componentInfo);
  std::swap(m_parent,right.m_parent);
  std::swap(m_elements,right.m_elements);
  //## end CGroupBase::swap%3A8C3F8A0352.body
}

void CGroupBase::resetComponentFlux ()
{
  //## begin CGroupBase::resetComponentFlux%3CB5F10F019D.body preserve=yes
  ComponentListConstIterator end=m_elements.end();
  ComponentListConstIterator beg=m_elements.begin();
  
  for (ComponentListConstIterator it = beg ;  it!=end; ++it)
  {
        (*it)->restoreUniquePhotonArray();
  }
  //## end CGroupBase::resetComponentFlux%3CB5F10F019D.body
}

std::vector<ModParam*> CGroupBase::getVariableParameters () const
{
  //## begin CGroupBase::getVariableParameters%3C7BA4EB0009.body preserve=yes
  ComponentListConstIterator cl = m_elements.begin();
  ComponentListConstIterator clEnd = m_elements.end();
  
  std::vector<ModParam*> vp;
  while (cl != clEnd)
  {
        std::vector<ModParam*> cvp = (*cl)->getVariableParameters();
        std::copy(cvp.begin(),cvp.end(),back_inserter(vp));
        ++cl;       
  }
  return vp;
  //## end CGroupBase::getVariableParameters%3C7BA4EB0009.body
}

const string& CGroupBase::parentName () const
{
  //## begin CGroupBase::parentName%3A8D3EB9010E.body preserve=yes
  //## end CGroupBase::parentName%3A8D3EB9010E.body

  return m_parent->name();
}

CGroupBase* CGroupBase::clone () const
{
  //## begin CGroupBase::clone%3A8D48BE001D.body preserve=yes
  //## end CGroupBase::clone%3A8D48BE001D.body

  return new CGroupBase(*this);
}

void CGroupBase::setElement (XSModExpTree<ComponentGroup*>& componentGroups)
{
  //## begin CGroupBase::setElement%3A8D4E7A0398.body preserve=yes
   int gt=0;
   int N (m_componentInfo->compSpecs().size());
   for ( int j = 0; j < N; ++j)
   {
      ComponentCreator create;
      const string& componentName = m_componentInfo->getComponentString(j);
      gt = componentName.find(ComponentGroup::GROUPTEST());
   // if this is not a symbol placeholder for a nested group...
   //  create a component of the appropriate type and read it.
      if ( gt < 0  )
      {                
         m_elements.push_back(create.GetComponent(componentName,this));
         incrementModelComponentCount();
         Component* newComponent = m_elements.back();
	 newComponent->index(m_componentInfo->getComponentSequence(j));
         updateExpression(newComponent, componentName, j);
      }
      else
   // if it is, store the address of the SumComponent that's in the
   // location nn given by  $GROUPnn.
      {
         int w = 0;
         string groupNo = componentName.substr(componentName.find_first_not_of(ComponentGroup::GROUPTEST()));
         sscanf (groupNo.c_str(),"%d",&w);
         ComponentGroup* cg = componentGroups.values()[w];
         SumComponent* gf = cg->groupFlux();

         gf->name(componentName);
         m_elements.push_back(gf);
      }
   }
  //## end CGroupBase::setElement%3A8D4E7A0398.body
}

size_t CGroupBase::dataGroup () const
{
  //## begin CGroupBase::dataGroup%3A9E94BA03BA.body preserve=yes
  //## end CGroupBase::dataGroup%3A9E94BA03BA.body

  return m_parent->dataGroupNumber();
}

void CGroupBase::registerParameters () const
{
  //## begin CGroupBase::registerParameters%3A9EA5690237.body preserve=yes
  ComponentListConstIterator rE(m_elements.begin());
  ComponentListConstIterator rEnd(m_elements.end());
  
  while (rE != rEnd)
  {
        (*rE)->registerParameters();
        ++rE;       
  }

  //## end CGroupBase::registerParameters%3A9EA5690237.body
}

size_t CGroupBase::parameterIndexBase () const
{
  //## begin CGroupBase::parameterIndexBase%3AA3FB9500DE.body preserve=yes
  //## end CGroupBase::parameterIndexBase%3AA3FB9500DE.body

  return m_parent->parameterIndexBase();
}

size_t CGroupBase::incrementModelParameterCount ()
{
  //## begin CGroupBase::incrementModelParameterCount%3AA558DF029E.body preserve=yes
  //## end CGroupBase::incrementModelParameterCount%3AA558DF029E.body

  return m_parent->incrementModelParameterCount();
}

size_t CGroupBase::incrementModelComponentCount ()
{
  //## begin CGroupBase::incrementModelComponentCount%3AA558EE01B3.body preserve=yes
  //## end CGroupBase::incrementModelComponentCount%3AA558EE01B3.body

  return m_parent->incrementModelComponentCount();
}

size_t CGroupBase::modelIndex () const
{
  //## begin CGroupBase::modelIndex%3AA696D10102.body preserve=yes
  //## end CGroupBase::modelIndex%3AA696D10102.body

  return m_parent->index();
}

Parameter* CGroupBase::getLocalParameter (size_t i) const
{
  //## begin CGroupBase::getLocalParameter%3AA92D1A0282.body preserve=yes
  //## end CGroupBase::getLocalParameter%3AA92D1A0282.body

  return m_parent->getLocalParameter(i);
}

Parameter* CGroupBase::localParameter (size_t i) const
{
  //## begin CGroupBase::localParameter%3AA93759014C.body preserve=yes
  ComponentListConstIterator rc(m_elements.begin());      
  ComponentListConstIterator rcEnd(m_elements.end());      
  Parameter* result(0);     
  while (rc != rcEnd)
  {
        if ( (result = (*rc)->localParameter(i)) != 0 ) break;
        ++rc;
  }
  return  result;
  //## end CGroupBase::localParameter%3AA93759014C.body
}

void CGroupBase::setElements (const string& componentName, const Component* newElement)
{
  //## begin CGroupBase::setElements%3AB672DF00DA.body preserve=yes
  ComponentListIterator rs(m_elements.begin());
  ComponentListIterator rsEnd(m_elements.end());
  
  
  while ( rs != rsEnd )
  {
        if  (  (*rs)->name() == componentName ) 
        {
                rs = m_elements.erase(rs);
                m_elements.insert(rs,newElement->clone(this));
                break;
        }
        ++rs;       
  }
  //## end CGroupBase::setElements%3AB672DF00DA.body
}

void CGroupBase::calculate (bool saveComponentFlux, bool frozen)
{
  //## begin CGroupBase::calculate%3AC8C3F002BC.body preserve=yes
  ComponentListIterator end=m_elements.end();
  ComponentListIterator beg=m_elements.begin();
  
  // scheme: perform the model calculations if needed.
  for (ComponentListIterator it = beg ;  it!=end; ++it)
  {
        // recompute component if parameters have changed.
        // the parameter changed attribute sets the recompute flag
        // to true if one or more of the parameters have changed.
        if ((*it)->recompute() | (*it)->isGroup() | frozen ) 
        {
                (*it)->calculate(saveComponentFlux,frozen);  
                // most of the time, we've calculated the model and don't need
                // to change it again until the parameter is changed. In the
                // case of 'frozen' used in computing norms, we will need to recompute
                // the entire model.
        }
 }
  //## end CGroupBase::calculate%3AC8C3F002BC.body
}

const ArrayContainer& CGroupBase::energyArray () const
{
  //## begin CGroupBase::energyArray%3AD322C800E5.body preserve=yes
  //## end CGroupBase::energyArray%3AD322C800E5.body

  return m_parent->energy();
}

SumComponent* CGroupBase::parenSum (ComponentListIterator& first, ComponentListIterator& last)
{
  //## begin CGroupBase::parenSum%3AE71AB7000C.body preserve=yes

  // any output from here is at chatter level 20 or higher
  XSstream::verbose(tpout,25,25);
  //tcout << "CGroupBase::parenSum\n";



  // declare an auto_ptr for the result of combining the components in
  // parentheses
  std::auto_ptr<SumComponent> totalGroupFlux;

  size_t jwords(0);
  size_t j(0);
  size_t lb = (m_componentInfo->parenLocs().first == string::npos) ?
                  0 : m_componentInfo->parenLocs().first;
  while (m_componentInfo->getComponentLocation(jwords) < lb ) 
          ++jwords;
  ComponentListIterator begin = first;

  while (begin != last  )
  {
     ComponentListIterator  run = begin;
     if ( j < m_componentInfo->plusLocs().size())
     {
        size_t pl = m_componentInfo->plusLocs()[j];        
        // 1) find an iterator to the first word after lb.
        // 2) find an iterator to the last word before pl.
        // create the group sum.  
        while (m_componentInfo->getComponentLocation(jwords) < pl) 
        {
           ++jwords;
           ++run;   
        } 
        if ( j == 0)  
        {
           SumComponent* term(calcSubgroup(begin,run));
           if ( !term->isGroup() ) 
           {
              totalGroupFlux.reset(term);  
           }
           else
           {
              totalGroupFlux.reset(term->clone(this));
           }
           totalGroupFlux->name("SUM");    
        }
        else
        {
           SumComponent* term(calcSubgroup(begin,run));
           *totalGroupFlux += *term;
           if ( !term->isGroup() ) delete term;
        }
        ++j;                    
        begin = run;     
     }
     else
     {
        if ( false )
        {

           tcout << "\nBegin " << (*run)->name() << '\n';                       
           tcout << "\nEnd " << " (end iterator)" << '\n';                   
           tcout << std::flush;                
        }
        SumComponent* term(calcSubgroup(run,last));
        *totalGroupFlux += *term;
        if ( !term->isGroup() ) delete term;
        begin = last;

     }
  }


  // output arrays if in high verbose mode
  totalGroupFlux->debugPrint(tcout,"\nModel Output CGroupBase::parenSum()");


  XSstream::verbose(tpout);
  return totalGroupFlux.release();
  //## end CGroupBase::parenSum%3AE71AB7000C.body
}

void CGroupBase::setComputeFlag (bool value)
{
  //## begin CGroupBase::setComputeFlag%3C20ECE700D3.body preserve=yes
  ComponentListConstIterator end=m_elements.end();
  ComponentListConstIterator beg=m_elements.begin();
  
  // scheme: perform the model calculations if needed.
  // recompute component if parameters have changed.
  // the parameter changed attribute sets the recompute flag
  // to true if one or more of the parameters have changed.
  // on initialization this might switch computing off altogether.
  // during a fit one probably needs manual control over this flag
  // as well. In principle also value could be false to use only
  // the last computed model.
  for (ComponentListConstIterator it = beg ;  it!=end; ++it)  (*it)->recompute(value);
  //## end CGroupBase::setComputeFlag%3C20ECE700D3.body
}

std::list<ModParam*> CGroupBase::normParams () const
{
  //## begin CGroupBase::normParams%3C6D2FF6009F.body preserve=yes
  std::list<ModParam*> norms;
  ComponentListConstIterator cEnd = m_elements.end();
  for (ComponentListConstIterator c = m_elements.begin(); c != cEnd; ++c)
  {
                  // ignore the SumComponents that represent groups.
          if ( !(*c)->isGroup())
          {
                AddComponent* a = dynamic_cast<AddComponent*> (*c);
                if (a)
                {
                        // every AddComponent has exactly one norm
                        // parameter of type ModParam, added on construction.
                        ModParam* p = static_cast<ModParam*>(a->parameter("norm"));
                        norms.push_back(p);
                }
          }            
  }       

  return norms;
  //## end CGroupBase::normParams%3C6D2FF6009F.body
}

void CGroupBase::clearArrays (const std::set<UniqueEnergy*>& currentEngs)
{
  //## begin CGroupBase::clearArrays%3C7670B103B8.body preserve=yes
  m_groupFlux->clearArrays(currentEngs);

  ComponentListIterator cEnd = m_elements.end();
  for (ComponentListIterator c = m_elements.begin(); c != cEnd; ++c)
  {                        
          if ( !(*c)->isGroup()) (*c)->clearArrays(currentEngs);
  }       
   
  //## end CGroupBase::clearArrays%3C7670B103B8.body
}

void CGroupBase::checkNorms (IntegerArray& paramsToFreeze) const
{
  //## begin CGroupBase::checkNorms%3C8915D502FC.body preserve=yes
  
  size_t zeroNorms (0);
  std::list<ModParam*> norms = normParams();
  std::list<ModParam*>::iterator ni = norms.begin();
  std::list<ModParam*>::iterator niEnd = norms.begin();

  // find out if there are any zero norms.

  while ( ni != niEnd )
  {
          if ( (*ni)->value('v') < SMALL ) ++zeroNorms;
  }
  if ( zeroNorms != 0 )
  {
          // if there are. Then, if all the norms are zero, add all of the
          // relevant param numbers to the 'to be temporarily frozen' list.

          if (zeroNorms == norms.size())
          {
                  ComponentListConstIterator cEnd = m_elements.end();
                  for (ComponentListConstIterator c = m_elements.begin(); c != cEnd; ++c)
                  {                        
                          std::vector<ModParam*> vp = (*c)->getVariableParameters();
                          size_t N = vp.size();
                          for ( size_t j = 0; j < N; ++j)
                          {
                                  paramsToFreeze.push_back(parent()->index() << 16 + 
                                                  vp[j]->index());
                          }
                  }
          }
          else
          {
                  // if however only some of the norms are frozen, then add
                  // the parameters of the 
                  ComponentListConstIterator cEnd = m_elements.end();
                  for (ComponentListConstIterator c = m_elements.begin(); c != cEnd; ++c)
                  {         
                          AddComponent* ac = dynamic_cast<AddComponent*>(*c);
                          if ( ac )    
                          {           
                                  std::vector<ModParam*> vp = ac->getVariableParameters();

                                  size_t N (vp.size());
                                  bool zero (false);
                                  for ( size_t j = 0; j < N; ++j)
                                  {
                                          if ( vp[j]->name() == "norm")
                                          {
                                                  if (vp[j]->value() < SMALL ) 
                                                  { 
                                                          zero = true;
                                                          break;
                                                  }       
                                          }
                                  }
                                  if ( zero )
                                  {
                                          for ( size_t j = 0; j < N; ++j)
                                          {
                                                  paramsToFreeze.push_back(parent()->index() 
                                                                  << 16 +  vp[j]->index());      
                                          }

                                  }       
                          }
                  }

          }
  }       
  //## end CGroupBase::checkNorms%3C8915D502FC.body
}

void CGroupBase::saveComponentFlux (bool setSaveFlux)
{
  //## begin CGroupBase::saveComponentFlux%3CB71C2400F1.body preserve=yes
  ComponentListConstIterator end=m_elements.end();
  ComponentListConstIterator beg=m_elements.begin();

  for (ComponentListConstIterator it = beg ;  it!=end; ++it)
  {
        (*it)->saveUniquePhotonArray(setSaveFlux);
  }
  //## end CGroupBase::saveComponentFlux%3CB71C2400F1.body
}

void CGroupBase::combine ()
{
  //## begin CGroupBase::combine%3D08C0FA00FE.body preserve=yes
  ComponentListIterator end=m_elements.end();
  ComponentListIterator beg=m_elements.begin();
  ComponentListIterator it=m_elements.begin();
  // combine nested subgroups. This is a recursive call to this function.
  while (it != end)
  {
     Component* current(*it);
     if (current->isGroup()) current->combine(); 
     ++it;
  }
  
  // sum the components.
  bool noParen(m_componentInfo->parenLocs().first == string::npos);
  
  if (noParen)
  {
     SumComponent* tmp(calcSubgroup(beg,end));
     *m_groupFlux = *tmp;
     if (!tmp->isGroup())
     {
        delete tmp;
     }
  }
  else
  {                
     ComponentListIterator parBeg(m_elements.begin());
     // there will be exactly one set of parentheses because of the definition
     // of a component group and the treatment of nested groups.  


     size_t jwords(0);

     // after model editing it is possible that there are no braces.
     // in which case sum everything by setting left and right brace
     // delimiters to the beginning and end of the string.
     size_t lb = (m_componentInfo->parenLocs().first == string::npos) ?
                        0 : m_componentInfo->parenLocs().first;
     size_t rb = (m_componentInfo->parenLocs().second == string::npos) ?
                  m_componentInfo->exprString().size() : 
                  m_componentInfo->parenLocs().second;

     while (m_componentInfo->getComponentLocation(jwords) < lb) 
     {
        ++parBeg;
        ++jwords;
     }

     ComponentListIterator parEnd(parBeg);
     while (parEnd != m_elements.end() && 
        m_componentInfo->getComponentLocation(jwords) < rb)
     {
        ++jwords;
        ++parEnd;
     }

     // replace the parentheses by a single SumComponent in a copy 
     // of the Component List and sum the result.

     std::auto_ptr<SumComponent> parenFlux(parenSum(parBeg,parEnd));       
        
     ComponentListIterator it(m_elements.begin());
     size_t nSkip = 0;
     size_t insIdx = 0;
     while ( it != parBeg )
     {
        ++it;
        ++insIdx;
     }
     while (it !=parEnd)
     {
        ++it;
        ++nSkip;
        ++insIdx;
     }
     --insIdx;
     SumComponent* tmpSum = calcSubgroup(m_elements.begin(),m_elements.end(),
                parenFlux.get(), insIdx, nSkip);
     *m_groupFlux = *tmpSum;
     // Due to above assignment, m_groupFlux has picked up tmpSum's 
     // Parameter* to an AddComp norm parameter.  m_groupFlux should
     // not retain this, otherwise if this is a nested CGroup, the
     // enclosing CGroup's SumComponent placeholder pointer will also
     // point to this norm parameter.  This condition caused parameter
     // linking errors when a data group copy model was made.
     std::vector<Parameter*> empty;
     m_groupFlux->setParameterSet(empty);
     if (!tmpSum->isGroup()) delete tmpSum;

  }
  
  // output arrays if in high verbose mode
 

  m_groupFlux->debugPrint(tcout," Model Output CGroupBase::combine() -");

        
  //## end CGroupBase::combine%3D08C0FA00FE.body
}

std::list<SumComponent*> CGroupBase::sources ()
{
  //## begin CGroupBase::sources%3DE7AD280095.body preserve=yes
   std::list<SumComponent*> sourceList;
   ComponentListIterator beg = m_elements.begin();
   ComponentListIterator end = m_elements.end();
   bool noParen(m_componentInfo->parenLocs().first==string::npos);
   if (noParen)
   {
      // This component group is of the form:
      // [mult comp]*..*[conv comp]*ADDCOMP*[mult comp]...
      // calcSubgroup WILL allocate memory for a new SumComponent.
      SumComponent *sumComp = calcSubgroup(beg, end);
      sourceList.push_back(sumComp);
      return sourceList;
   }
   else
   {
      // There are 1 and only 1 set of parentheses.
      // Find the first and last of the elements inside 
      // the parentheses. (parEnd will point to the element AFTER the 
      // right parenthesis, or to the end.)
      ComponentListIterator parBeg = beg;
      size_t iwords = 0, jwords = 0;
      size_t lb = (m_componentInfo->parenLocs().first == string::npos) ?
                         0 : m_componentInfo->parenLocs().first;
      size_t rb = (m_componentInfo->parenLocs().second == string::npos) ?
                   m_componentInfo->exprString().size() : 
                   m_componentInfo->parenLocs().second;
      while (m_componentInfo->getComponentLocation(iwords) < lb) 
      {
         ++parBeg;
         ++iwords;
      }
      jwords = iwords;
      ComponentListIterator parEnd = parBeg;
      while (parEnd != end && 
        m_componentInfo->getComponentLocation(jwords) < rb)
      {
         ++jwords;
         ++parEnd;
      }
      const size_t nSkip = jwords - iwords;
      const size_t insertIdx = jwords - 1;
      // The parenList function will recursively call back on this
      // function for any nested groups between the parentheses.
      sourceList = parenList(iwords, parBeg, parEnd);
      // Now apply any mult or conv components that appear outside
      // the parentheses. 
      std::list<SumComponent*>::iterator itSl = sourceList.begin();
      std::list<SumComponent*>::iterator itSlEnd = sourceList.end();
      while (itSl != itSlEnd)
      {
         SumComponent* innerSC = *itSl;
         *itSl = calcSubgroup(m_elements.begin(),m_elements.end(),innerSC,
                        insertIdx, nSkip);
         delete innerSC;
         ++itSl;
      }
   }
        
   return sourceList;     
  //## end CGroupBase::sources%3DE7AD280095.body
}

std::list<SumComponent*> CGroupBase::parenList (int iWord, const ComponentListIterator& first, const ComponentListIterator& last)
{
  //## begin CGroupBase::parenList%3DE7AD480002.body preserve=yes
  std::list<SumComponent*> sourceList;
  ComponentListIterator startSubGroup = first;  
  size_t iPlus=0;      
  while (iPlus <= m_componentInfo->plusLocs().size())
  {
     SumComponent *groupTest = dynamic_cast<SumComponent*>(*startSubGroup);
     if (groupTest)
     {
        // For nested groups, don't do anything on this level,
        // but handle it with a RECURSIVE CALL to CGroupBase::sources().
        std::list<SumComponent*> groupList = groupTest->sources();
        sourceList.insert(sourceList.end(), groupList.begin(), groupList.end());
         
        // A group must be the ONLY word and component in 
        // between plus signs.
        ++iPlus;
        ++iWord; 
        ++startSubGroup;
     }
     else
     {
        ComponentListIterator endSubGroup;
        if (iPlus == m_componentInfo->plusLocs().size())
        {
           endSubGroup = last;
        }
        else
        {
           size_t pl = m_componentInfo->plusLocs()[iPlus];
           endSubGroup = startSubGroup;
           // If this else block is reached, the while loop below
           // should have to execute at least once....Another way
           // of saying that if there is still a plus sign to process,
           // we must be starting with a word (and component) to the
           // left of it.
           while (m_componentInfo->getComponentLocation(iWord) < pl)
           {
              ++iWord;
              ++endSubGroup;
           }           
        }
        // calcSubgroup will allocate the sumComp memory.
        SumComponent *sumComp = calcSubgroup(startSubGroup, endSubGroup);
        sourceList.push_back(sumComp);        
        startSubGroup = endSubGroup;
        ++iPlus;
     }
  }

  return sourceList;
  //## end CGroupBase::parenList%3DE7AD480002.body
}

size_t CGroupBase::modelComponentCount ()
{
  //## begin CGroupBase::modelComponentCount%3EE0D654024A.body preserve=yes
  //## end CGroupBase::modelComponentCount%3EE0D654024A.body

  return m_parent->modelComponentCount();
}

size_t CGroupBase::modelParameterCount ()
{
  //## begin CGroupBase::modelParameterCount%3EE0D6710320.body preserve=yes
  //## end CGroupBase::modelParameterCount%3EE0D6710320.body

  return m_parent->modelParameterCount();
}

void CGroupBase::deleteComponent (int sequenceNumber, int index)
{
  //## begin CGroupBase::deleteComponent%3EF9EC15034F.body preserve=yes
  ComponentListIterator doomed(m_elements.begin());
  for (int ic = 0; ic < sequenceNumber; ++ic) ++doomed;
  delete *doomed;
  m_elements.erase(doomed);
  m_componentInfo->deleteWordBySequence(index);
  //## end CGroupBase::deleteComponent%3EF9EC15034F.body
}

void CGroupBase::setNestedElement (const string& componentName, Component* newElement)
{
  //## begin CGroupBase::setNestedElement%3F01F46C024D.body preserve=yes
  ComponentListIterator rs(m_elements.begin());
  ComponentListIterator rsEnd(m_elements.end());
  
  // nested element does not reset pointer to current component group.
  while ( rs != rsEnd )
  {
        if  (  (*rs)->name() == componentName ) 
        {
                // delete current pointer and replace with nested version.
                // setNestedElement is called from ModelBase::clone which has
                // just created ptrs like rs.
                delete *rs;
                rs = m_elements.erase(rs);
                m_elements.insert(rs,newElement);
                break;
        }
        ++rs;       
  }  
  //## end CGroupBase::setNestedElement%3F01F46C024D.body
}

void CGroupBase::resetElement (XSModExpTree<ComponentGroup*>& newGroups, const std::vector<Component*>& existingComponents)
{
  //## begin CGroupBase::resetElement%3F1EBC0302E5.body preserve=yes
   const size_t nComps = m_componentInfo->compSpecs().size();
   for (size_t i=0; i<nComps; ++i)
   {
      const string& componentName = m_componentInfo->getComponentString(i);
      if (componentName.find(ComponentGroup::GROUPTEST()) ==
            string::npos)
      {
         // This gets the word sequence, which corresponds to component 
         // index number.
         int newIndex = m_componentInfo->getComponentSequence(i);
         Component* compToTransfer = existingComponents[newIndex-1];
         compToTransfer->index(newIndex);
         compToTransfer->setParent(this);
         m_elements.push_back(compToTransfer);
      }
      else
      {
         // Store the address of the SumComponent that's in
         // the location nn given by  $GROUPnn.
	 int w = 0;
	 string groupNo = componentName.substr(componentName.find_first_not_of(ComponentGroup::GROUPTEST()));
	 sscanf (groupNo.c_str(),"%d",&w);
         ComponentGroup* cg = newGroups.values()[w];
	 SumComponent* gf = cg->groupFlux();

	 gf->name(componentName);
	 m_elements.push_back(gf);
      }
   }
  //## end CGroupBase::resetElement%3F1EBC0302E5.body
}

Component* CGroupBase::element (int index) const
{
  //## begin CGroupBase::element%3F1ECCDE0327.body preserve=yes
  Component* target(0);
  ComponentListConstIterator cl = m_elements.begin();
  ComponentListConstIterator clEnd = m_elements.end();
  while ( cl != clEnd && !target )
  {
        if ( (*cl)->index() == index ) target = *cl;
        ++cl;       
  }
  
  return target;
  //## end CGroupBase::element%3F1ECCDE0327.body
}

void CGroupBase::insertComponent (int location, int index, const string& name, char op)
{
  //## begin CGroupBase::insertComponent%3F26BBE2031B.body preserve=yes
    ComponentListIterator ic (m_elements.begin());
    ComponentCreator create;
    Component::getSetupData(name);
    string fullName(Component::currentModelName());
    Component* newComponent (create.GetComponent(fullName,this));
    newComponent->index(index);
    m_componentInfo->insertWordBySequence(index,fullName,op);

    addToElements(location, newComponent);

    ic = m_elements.begin();
    ComponentListIterator icEnd = m_elements.end();
    // This call is only needed in case of table models, particularly
    // if a re-prompt for file name was necessary.
    updateExpression(newComponent, fullName, location);
    incrementModelComponentCount();
  //## end CGroupBase::insertComponent%3F26BBE2031B.body
}

void CGroupBase::exchangeComponent (int location, Component* newComponent)
{
  //## begin CGroupBase::exchangeComponent%45129B1B03BE.body preserve=yes
   // Introduced for use by editmod exchange:
   // Simply replace an existing component pointer with a new one
   // created from the input name.  This will DESTROY the old
   // component, so it ASSUMES all parameter deregistering has
   // been done already.
   Component* oldComponent = 0;
   int count = 0;
   ComponentListIterator itComp = m_elements.begin();
   ComponentListIterator itEnd = m_elements.end();
   if (static_cast<size_t>(location) < m_elements.size())
   {
      while (count != location && itComp != itEnd)
      {      
         ++itComp;
         ++count;
      }
      if (itComp != itEnd)
         oldComponent = *itComp;
   }
   if (!oldComponent)
   {
      std::ostringstream oss;
      oss << "Error searching for component at location " << location
         << " in CGroupBase::exchangeComponent.\n";
      throw RedAlert(oss.str());
   }
   *itComp = newComponent;
   newComponent->index(oldComponent->index());
   delete oldComponent;
  //## end CGroupBase::exchangeComponent%45129B1B03BE.body
}

Component* CGroupBase::createComponent (string& name)
{
  //## begin CGroupBase::createComponent%4512D8BA0328.body preserve=yes
   // Introduced for use in editmod, to ensure new component can be created 
   // before modifying anything in its ultimately intended model.  This
   // function can throw.
   ComponentCreator create;
   Component::getSetupData(name);
   string fullName(Component::currentModelName());
   Component* newComponent (create.GetComponent(fullName,this));
   // file name may have changed due to re-prompting while in
   // create.GetComponent.
   string tableModName = checkCurrentTableModelExpr(newComponent, name);
   if (tableModName.length())
      name = tableModName;
   return newComponent;
  //## end CGroupBase::createComponent%4512D8BA0328.body
}

void CGroupBase::deregisterParameters () const
{
  //## begin CGroupBase::deregisterParameters%3F297F040034.body preserve=yes
  ComponentListConstIterator rE(m_elements.begin());
  ComponentListConstIterator rEnd(m_elements.end());
  
  while (rE != rEnd)
  {
        (*rE)->deregisterParameters();
        ++rE;       
  }
  //## end CGroupBase::deregisterParameters%3F297F040034.body
}

Component* CGroupBase::firstComponent ()
{
  //## begin CGroupBase::firstComponent%3F72045B00D1.body preserve=yes
  if ( !m_elements.empty() ) return m_elements.front();
  else return 0;
  //## end CGroupBase::firstComponent%3F72045B00D1.body
}

void CGroupBase::resizeElements (size_t n)
{
  //## begin CGroupBase::resizeElements%405B62F6017A.body preserve=yes
    m_elements.resize(n);
  //## end CGroupBase::resizeElements%405B62F6017A.body
}

void CGroupBase::addToElements (int componentOffset, Component* newComponent)
{
  //## begin CGroupBase::addToElements%4134D20403B7.body preserve=yes
    ComponentListIterator ic = m_elements.begin();

    if ( componentOffset < static_cast<int>(m_elements.size()))
    {
        for (int j = 0; j < componentOffset; ++j)
	    ++ic;

        ic = m_elements.insert(ic, newComponent);
    }
    else // no indexes to update.
	m_elements.push_back(newComponent);
    newComponent->setParent(this);
  //## end CGroupBase::addToElements%4134D20403B7.body
}

const std::set<UniqueEnergy*>& CGroupBase::uniqueEnergyArray () const
{
  //## begin CGroupBase::uniqueEnergyArray%43D64D510301.body preserve=yes
   return m_parent->getUniqueEnergies();
  //## end CGroupBase::uniqueEnergyArray%43D64D510301.body
}

void CGroupBase::updateExpression (Component* newComponent, const string& oldName, size_t wordIdx)
{
  //## begin CGroupBase::updateExpression%451167440301.body preserve=yes
   // If this is a table model, it's possible the file name has 
   // changed as a result of re-prompting.  Therefore we need
   // to re-insert this possibly new name back into the expression.
   string tableName(checkCurrentTableModelExpr(newComponent, oldName));
   if (tableName.length())
      m_componentInfo->setComponentString(tableName, wordIdx);
   else
      m_componentInfo->setComponentString(newComponent->name(),wordIdx);
  //## end CGroupBase::updateExpression%451167440301.body
}

string CGroupBase::checkCurrentTableModelExpr (const Component* component, const string& prevExprString)
{
  //## begin CGroupBase::checkCurrentTableModelExpr%4512C27C00CE.body preserve=yes
   string newComponentName;
   if (const AddTableComponent* addTable = dynamic_cast<const AddTableComponent*>(component))
   {
      const string& newFileName = addTable->tableFile();
      newComponentName = "atable{" + newFileName + "}";
   }
   else if (const MulTableComponent* mulTable = dynamic_cast<const MulTableComponent*>(component))
   {
      const string& newFileName = mulTable->tableFile();
      // This could begin with mtable or etable.  If it made it
      // this far, oldName has already been validated and only
      // need to check 'eE' or 'mM'.
      if (prevExprString[0] == 'e' || prevExprString[0] == 'E')
         newComponentName = "etable{";
      else
         newComponentName = "mtable{";
      newComponentName += newFileName + "}";
   }
   return newComponentName;
  //## end CGroupBase::checkCurrentTableModelExpr%4512C27C00CE.body
}

std::vector<size_t> CGroupBase::postfixOperatorLocs (size_t endIdx, size_t nComps, size_t skipIdx, size_t nSkip) const
{
  //## begin CGroupBase::postfixOperatorLocs%48F4F851013B.body preserve=yes
   // ASSUME nComps from right to left starting with endIdx contain no 
   // non-skipped "+" operations.
   std::vector<size_t> starLocs;
   
   size_t curIdx = endIdx;
   
   string::size_type compLoc = 
      static_cast<string::size_type>(m_componentInfo->getComponentLocation(curIdx));
   string exprStr = m_componentInfo->exprString();
   if (nSkip)
   {
      // This is a final summation.  Additive parens and everything 
      // inside them will be replaced by a single sum component.
      string::size_type lPar = m_componentInfo->parenLocs().first;
      string::size_type rPar = m_componentInfo->parenLocs().second;
      exprStr.replace(lPar, rPar-lPar, rPar-lPar, ' ');
   }
   string::size_type rParenLoc = exprStr.rfind(')',compLoc);
   string::size_type lParenLoc = exprStr.rfind('(',compLoc);
   std::stack<char> opHolder;
   bool isDone = false;
   bool starPending = false;
   size_t compsProcessed = 0;
   while (!isDone)
   {
      // If rParenLoc != npos, then lParenLoc != npos.
      if (rParenLoc != string::npos && rParenLoc > compLoc
                && rParenLoc > lParenLoc)
      {
         if (starPending)
         {
            opHolder.push('*');
            starPending = false;
         }
         opHolder.push(')');
         rParenLoc = exprStr.rfind(')',rParenLoc-1);
      }
      else if (lParenLoc != string::npos && lParenLoc > rParenLoc 
                && lParenLoc > compLoc)
      {
         while (!opHolder.empty() && opHolder.top() != ')')
         {
            starLocs.push_back(curIdx);
            opHolder.pop();
         }
         if (!opHolder.empty())
            opHolder.pop();  // remove the matching ')'
         
         // Careful, lParenLoc can be 0.
         lParenLoc = lParenLoc ? exprStr.rfind('(',lParenLoc-1) : string::npos;
      }
      else
      {
         // There should ultimately be N-1 '*' operators for N components.
         // So for each encountered component, set a starPending flag.
         // It will be pushed onto the stack as soon as the next model
         // component or ')' is encountered.  ie. we want a*(b*c) and
         // not a(*b*c).  Also note that the last pending star will NOT
         // be pushed onto the stack, thus N-1.
         if (starPending)
         {
            starLocs.push_back(curIdx);
         }
         starPending = true;
         if (nSkip && curIdx == skipIdx)
         {
            curIdx -= nSkip;
            compsProcessed += nSkip;
         }
         else
         {
            --curIdx;
            ++compsProcessed;
         }
         if (compsProcessed == nComps)
            isDone = true;
         else
            compLoc = static_cast<string::size_type>(m_componentInfo->getComponentLocation(curIdx));
      }
      
   }
   
   // Remaining left pars mean that opHolder still contains '*'s.
   while (!opHolder.empty())
   {
      if (opHolder.top() == '*')
         starLocs.push_back(endIdx+1-nComps);
      opHolder.pop();
   }   

   // debug
/*   for (size_t i=0; i<starLocs.size(); ++i)
      tcout <<starLocs[i]<<" ";
   tcout <<std::endl;
*/         
   return starLocs;
  //## end CGroupBase::postfixOperatorLocs%48F4F851013B.body
}

SumComponent* CGroupBase::calcSubgroup (ComponentListIterator begin, ComponentListIterator end, SumComponent* insert, size_t insIdx, size_t nSkip)
{
  //## begin CGroupBase::calcSubgroup%48FF890F02A2.body preserve=yes
   if (begin == end)
      throw RedAlert("Empty component list in CGroupBase::calcSubgroup.");
      
   // Need to know where end is in relation to the full component group.
   // Could use the distance function for these, but Solaris has had problems
   // with it in the past when applied to lists, so do it the old-fashioned way.
   ComponentListConstIterator itCur(m_elements.begin());
   size_t endIdx = 0;
   while (itCur != begin)
   {
      ++itCur;
      ++endIdx;
   }
   size_t nComps = 0; 
   while (itCur != end)
   {
      ++itCur;
      ++nComps;
      ++endIdx;
   }
   if (!nComps)
      throw RedAlert("No components found in CGroupBase::calcSubgroup");
   --endIdx;
      
   if (nComps == 1 && (*begin)->toSumComponent() && !insert)
   {
      // This is a GROUP.
      return (*begin)->toSumComponent();
   }    
      
   std::vector<size_t> starLocs = postfixOperatorLocs(endIdx, nComps, insIdx, nSkip);
   
   // Input end argument is one beyond the last (or first going from right 
   // to left) component we want.
   --itCur;
   size_t nextComp = endIdx;  
  
   SumComponent* subgroup = 0;      
   std::stack<Component*> compStack;
   
   const size_t nStars = starLocs.size();
   size_t iStar = 0;
   size_t nextStar = nStars ? starLocs[0] : string::npos;
   const size_t nItems = insert ? nStars+nComps-nSkip+1 : nStars + nComps ;
   for (size_t iItem=0; iItem<nItems; ++iItem)
   {
      if (nextStar != string::npos && (nextStar > nextComp || nextComp == string::npos))
      {
         if (compStack.size() < 2)
            throw RedAlert("Components missing during CGroupBase::calcSubgroup multiplication.");
         // The second component from the top must always be a SumComponent.   
         Component* first = compStack.top();
         compStack.pop();
         Component* second = compStack.top();
         compStack.pop();
         subgroup = second->toSumComponent();
         if (!subgroup)
            throw RedAlert("SumComponent missing during CGroupBase::calcSubgroup multiplication.");
         
         // If first is an AddComponent, it couldn't have been normalized 
         // in the section below.  Do it now before combining with subgroup.
         if (AddComponent* add = dynamic_cast<AddComponent*>(first))
         {
            SumComponent tmpSC(*add);
            tmpSC.normalize();
            (*subgroup) *= tmpSC;
         }
         else
            (*subgroup) *= (*first);
         compStack.push(subgroup); 
         if (first->toSumComponent() && first != insert)
            delete first; 
                      
         ++iStar;
         nextStar = (iStar < nStars) ? starLocs[iStar] : string::npos;
      }
      else
      {
         // If component is not followed by a star in postfix, it is either
         // the calc beginning (rightmost), or to the left of an ')'.  
         // It must be converted to a SumComponent.
         Component* comp = *itCur;
         if (insert && nextComp == insIdx)
            comp = insert;
         if ((comp != insert && nextStar != nextComp) ||
             (comp == insert && nextStar != nextComp + 1 - nSkip))
         {
            if (AddComponent* add = dynamic_cast<AddComponent*>(comp))
            {
               subgroup = new SumComponent(*add);
               subgroup->normalize();
            }
            else if (MulComponent* mul = dynamic_cast<MulComponent*>(comp))
               subgroup = new SumComponent(*mul);
            else if (comp == insert)
               subgroup = new SumComponent(*insert);
            else
               throw RedAlert("Invalid first component in CGroupBase::calcSubgroup.");
            compStack.push(subgroup);            
         }
         else
            compStack.push(comp);
         if (!nextComp)
            nextComp = string::npos;
         else
         {
            if (insert && nextComp == insIdx)
            {
               nextComp = (nSkip > nextComp) ? string::npos : nextComp - nSkip;
               for (size_t i=0; i<nSkip; ++i)
                  --itCur;
            }
            else
            {
               --nextComp;
               --itCur;
            }
         }
      }
   }
   return subgroup;
  //## end CGroupBase::calcSubgroup%48FF890F02A2.body
}

// Additional Declarations
  //## begin CGroupBase%3A8C3E710351.declarations preserve=yes
  //## end CGroupBase%3A8C3E710351.declarations

//## begin module%3A8C3FDD038A.epilog preserve=yes
//## end module%3A8C3FDD038A.epilog
